const express = require('express');
const router = express.Router();
const multer = require('multer');
const authorize = require('../../../../middlewares/authorize-sapps');
const branchService = require('./branch.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new branch
 * @param {Object} req.body - The branch data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created branch
 */
function create(req, res, next) {
    branchService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all branchs
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of branchs
 */
function getAll(req, res, next) {
    branchService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of branch objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of branch objects
 */
function option(req, res, next) {
    branchService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of branchs matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of branchs
 */
function count(req, res, next) {
    branchService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing branch
 * @param {number} req.params.id - The branch ID to be updated
 * @param {Object} req.body - The branch data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated branch
 */
function update(req, res, next) {
    branchService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a branch
 * @param {number} req.params.id - The branch ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    branchService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
